## dpkg 1.22.2ubuntu2

=== debian/changelog ===
dpkg (1.22.2ubuntu2) noble; urgency=medium

  * Set zstd compression level back to 19. (LP: #2048137)

 -- Dan Bungert <daniel.bungert@canonical.com>  Thu, 04 Jan 2024 17:24:19 -0700

dpkg (1.22.2ubuntu1) noble; urgency=medium

  * Merge from Debian unstable.  Remaining changes:
    - Change native source version/format mismatch errors into warnings
      until the dust settles on Debian bug 737634 about override options.
    - Add DPKG_UNTRANSLATED_MESSAGES environment check so that higher-level
      tools can get untranslated dpkg terminal log messages while at the
      same time having translated debconf prompts.
    - Map unqualified package names of multiarch-same packages to the native
      arch instead of throwing an error, so that we don't break on upgrade
      when there are unqualified names stored in the dpkg trigger database.
    - Apply a workaround from mvo to consider ^rc packages as multiarch,
      during the dpkg consistency checks. (see LP: 1015567 and 1057367).
    - dpkg-gencontrol: Fix Package-Type override handling for ddeb support.
    - scripts/Dpkg/Vendor/Ubuntu.pm, scripts/dpkg-buildpackage.pl: set
      'nocheck' in build options by default on Ubuntu/riscv64.  Overridable
      in debian/rules with
      'DEB_BUILD_OPTIONS := $(filter-out nocheck,$(DEB_BUILD_OPTIONS))'.
    - dpkg-dev: Depend on lto-disabled-list.
    - dpkg-buildflags: Read package source names from lto-disabled-list,
      to build without lto optimizations. When adding a source package to the
      list, please also file a launchpad issue and tag it with 'lto'.
    - scripts/Dpkg/Vendor/Ubuntu.pm: set 'noudeb' build profile by
      default. Override this by exporting DEB_BUILD_PROFILE='!noudeb' which
      will be stripped, and thus building with udebs.
    - build: Switch default dpkg-deb compression from xz to zstd.
      Keep compressing dpkg.deb with xz to help bootstrapping on non-Ubuntu
      systems.
    - set default zstd compression level to 19
    - scripts/Dpkg/Vendor/Debian.pm: Always include "-fdebug-prefix-map"
      to build flags.  Map path to "/usr/src/PKGNAME-PKGVER" instead of
      ".", honouring the DWARF standard which prohibits relative paths
      in DW_AT_comp_dir.
    - scripts/{mk/buildflags.mk,t.mk}: Add support for DEB_BUILD_DEBUGPATH.
    - man/dpkg-buildflags.pod: Document new behaviour of "fdebugmap" and
      new DEB_BUILD_DEBUGPATH variable.
    - Disable -fstack-clash-protection on armhf since it causes crashes
    - dpkg-buildflags: Add a new feature "framepointer" in the "qa" area.
    - Turn on the use of frame pointers by default on 64bit architectures.
    - Switch _FORTIFY_SOURCE to 3 by default instead of 2 when hardening is
      enabled
    - Update _FORTIFY_SOURCE documentation.
    - Update Dpkg_BuildFlags test case.
    - Don't install dpkg-fsys-usrunmess script.
  * Dropped changes, no longer needed:
    - Special-case arm{el,hf} ELF objects in Shlibs/Objdump.pm for multilib:
      only relevant for armel which is obsolete in Ubuntu.
  * Fix debian/rules duplicate invocations of dh_builddeb
  * lib/dpkg/compress.c: clean up override of the default zstd compression
    level
  * Drop a delta to man/dpkg-deb.pod, %DEB_DEFAULT_COMPRESSOR% expands to
    the correct value for us (zstd).

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 19 Dec 2023 16:28:05 -0800

dpkg (1.22.2) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-shlibdeps: Do not require debian/control when parsing CLI options.
    Closes: #1055536
  * Architecture support:
    - Remove arm64ilp32 support.
      See https://lists.debian.org/debian-dpkg/2023/11/msg00007.html.
    - Remove uclinux support.
      See https://lists.debian.org/debian-dpkg/2023/11/msg00012.html.
    - Remove knetbsd-any support.
    - Restrict kfreebsd ports to amd64 and i386.
    - Restrict kopensolaris ports to amd64 and i386.
    - Restrict hurd ports to amd64 and i386.
    - Restrict dragonflybsd ports to amd64.
    - Restrict aix ports to powerpc and ppc64.
    - Restrict solaris ports to amd64, i386, sparc and sparc64.
    - Restrict darwin ports to amd64, arm, arm64, i386, powerpc and ppc64.
    - Restrict freebsd ports to amd64, arm, arm64, i386, powerpc, ppc64, riscv.
    - Split tupletable header names description into two paragraphs.
  * Perl modules:
    - Dpkg::OpenPGP::Backend::Sequoia: Switch to use --signer-file.
    - Dpkg::Vendor::Debian: Mask PIE for alpha and ia64. Closes: #1040062
    - Dpkg::Control::Types: Add aliases for type enumerations.
  * Documentation:
    - man: Add dpkg-build-api behavior for Rules-Requires-Root field defaults.
    - man: Improve description for dpkg-build-api v1 items.
    - doc, man: Clarify terminology for Debian control files.
  * Code internals:
    - libcompat: Disable VLA usage for gettext.h.
    - libdpkg: Remove dead code after non-returning error function call.
    - libdpkg: Mark varbuf constructor as explicit.
    - Reduce variables scope.
    - update-alternatives: Wrap the bad_format() function pointer call into a
      new function.
    - start-stop-daemon: Rename local variables shadowing global info()
      function name.
    - libdpkg: Add underscore after NO to FHFF_NONEW and FHFF_NOCOPY enum
      values.
    - Use FHFF_NONE instead of a literal 0 in calls to fsys_hash_find_node().
      Reported by Alexandre Detiste <alexandre.detiste@gmail.com>.
    - dpkg-split: Change heading print logic to use a proper boolean.
    - dpkg-shlibdeps: Defer add_library_dir() calls after option parsing.
    - libdpkg: Remove unused DEFAULTSHELL and DEFAULTPAGER macros.
    - dpkg-buildapi: Do not include newline in Usage text to be translated.
  * Build system:
    - Check whether we need to linkg against libtinfo explicitly.
    - Add support for structured procfs via struct psinfo.
    - Replace action-if-found with : for extra libselinux check.
    - Check and print sizeof off_t and time_t on the configure summary.
  * Packaging:


=== debian/control ===
Source: dpkg
Section: admin
Priority: required
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
Uploaders: Guillem Jover <guillem@debian.org>
Homepage: https://wiki.debian.org/Teams/Dpkg
Vcs-Browser: https://git.dpkg.org/cgit/dpkg/dpkg.git
Vcs-Git: https://git.dpkg.org/git/dpkg/dpkg.git
Standards-Version: 4.6.2
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 debhelper (>= 13.10~),
 pkgconf,
# Version needed for ITS support.
 gettext (>= 0.19.7),
# Version needed for --porefs defaults, conditional addenda and mode=eof.
 po4a (>= 0.59),
 libmd-dev,
 zlib1g-dev,
 libbz2-dev,
# Version needed for multi-threaded decompressor support.
 liblzma-dev (>= 5.4.0),
# Version needed for the new streaming API.
 libzstd-dev (>= 1.4.0),
 libselinux1-dev [linux-any],
 libncurses-dev (>= 6.1+20180210),
# Needed for the functional test.
 bzip2 <!nocheck>,
# Version needed for multi-threaded decompressor support.
 xz-utils (>= 5.4.0) <!nocheck>,
# Needed for the functional test.
 zstd <!nocheck>,
# Needed for the author release process.
 git <pkg.dpkg.author-release>,
 ca-certificates <pkg.dpkg.author-release>,
 libmodule-build-perl <pkg.dpkg.author-release>,
# Needed for the test suite in author mode.
 fakeroot <pkg.dpkg.author-testing>,
 gnupg <pkg.dpkg.author-testing>,
 cppcheck <pkg.dpkg.author-testing>,
 shellcheck <pkg.dpkg.author-testing>,
 aspell <pkg.dpkg.author-testing>,
 aspell-en <pkg.dpkg.author-testing>,
 codespell <pkg.dpkg.author-testing>,
 i18nspector <pkg.dpkg.author-testing>,
 libtest-minimumversion-perl <pkg.dpkg.author-testing>,
 libtest-perl-critic-perl <pkg.dpkg.author-testing>,
 libtest-pod-coverage-perl <pkg.dpkg.author-testing>,
 libtest-pod-perl <pkg.dpkg.author-testing>,
 libtest-spelling-perl <pkg.dpkg.author-testing>,
 libtest-strict-perl <pkg.dpkg.author-testing>,
 libtest-synopsis-perl <pkg.dpkg.author-testing>,
# Needed for code coverage reports.
 lcov <pkg.dpkg.code-coverage>,
 libdevel-cover-perl <pkg.dpkg.code-coverage>,

Package: dpkg
Architecture: any
Multi-Arch: foreign
Essential: yes
Pre-Depends:
 ${shlibs:Depends},
Depends:
 ${misc:Depends},
# Version needed for --clamp-mtime in dpkg-deb -b.
 tar (>= 1.28-1),
Suggests:
 apt,
 debsig-verify,
Breaks:
# Due to --status-fd not duplicating output.
 libapt-pkg5.0 (<< 1.7~b),
# Due to s-s-d requiring secure usage of --pidfile.
 lsb-base (<< 10.2019031300),
Description: Debian package management system
 This package provides the low-level infrastructure for handling the
 installation and removal of Debian software packages.
 .
 For Debian package development tools, install dpkg-dev.

Package: libdpkg-dev
Section: libdevel
Priority: optional
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 libmd-dev,
 zlib1g-dev,
# Version needed for multi-threaded decompressor support.
 liblzma-dev (>= 5.4.0),
# Version needed for the new streaming API.
 libzstd-dev (>= 1.4.0),
 libbz2-dev,
Description: Debian package management static library
 This package provides the header files and static library necessary to
 develop software using libdpkg, the same library used internally by dpkg.
 .
 Note though, that the API is to be considered volatile, and might change
 at any time, use at your own risk.

Package: dpkg-dev
Section: utils
Priority: optional
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${perl:Depends},
 libdpkg-perl (= ${source:Version}),
# Version needed for --clamp-mtime.
 tar (>= 1.28-1),
 bzip2,
# Version needed for multi-threaded decompressor support.
 xz-utils (>= 5.4.0),
# Version needed for git-style diff support.
 patch (>= 2.7),
 make,
 binutils,
 lto-disabled-list,
Recommends:
 build-essential,
 gcc | c-compiler,
 fakeroot,
 gnupg | sq | sqop | pgpainless-cli,
 gpgv | sq | sqop | pgpainless-cli,
# Used by dpkg-mergechangelogs.
 libalgorithm-merge-perl,
Suggests:
 debian-keyring,
Breaks:
# Force R³ support, w/o requiring debhelper users to depend on dpkg-dev.
 debhelper (<< 10.10.1~),
# Uses new sq features, w/o requiring a hard dependency on sq.
 sq (<< 0.28.0~),
# Uses required SOP features, w/o requiring a hard dependency on sqop.
 sqop (<< 0.27.2~),
# Uses required SOP features, w/o requiring a hard dependency on pgpainless.
 pgpainless-cli (<< 1.3.13~),
 libsop-java-java (<< 4.0.7~),
Provides:
 dpkg-build-api (= 0),
 dpkg-build-api (= 1),
Description: Debian package development tools
 This package provides the development tools (including dpkg-source)
 required to unpack, build and upload Debian source packages.
 .
 Most Debian source packages will require additional tools to build;
 for example, most packages need make and the C compiler gcc.

Package: libdpkg-perl
Section: perl
Priority: optional
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${perl:Depends},
# Version needed for arch tuples.
 dpkg (>= 1.18.11),
Recommends:
# Used by Dpkg::File.
 libfile-fcntllock-perl,
# Used by Dpkg::Gettext.
 liblocale-gettext-perl,
 bzip2,
# Version needed for multi-threaded decompressor support.
 xz-utils (>= 5.4.0),
Suggests:
 debian-keyring,
 gnupg | sq | sqop | pgpainless-cli,
 gpgv | sq | sqop | pgpainless-cli,
 gcc | c-compiler,
 binutils,
 patch,
# Used (if available) by Dpkg::Source::Package::V2.
 sensible-utils,
# Needed by Dpkg::Source::Package::V3::Git
 git,
# Needed by Dpkg::Source::Package::V3::Bzr
 bzr,
Breaks:
# Uses the private Dpkg::Shlibs::SymbolFile module with no API stability
# guarantees! Which obviously broke with 1.19.0.
 pkg-kde-tools (<< 0.15.28~),
# Uses Dpkg::Compression::Process imported from Dpkg::Source::Package in
# versions prior to 1.19.0.
 dgit (<< 3.13~),
# Uses new sq features, w/o requiring a hard dependency on sq.
 sq (<< 0.28.0~),
# Uses required SOP features, w/o requiring a hard dependency on sqop.
 sqop (<< 0.27.2~),
# Uses required SOP features, w/o requiring a hard dependency on pgpainless.
 pgpainless-cli (<< 1.3.13~),
 libsop-java-java (<< 4.0.7~),
Description: Dpkg perl modules
 This package provides the perl modules used by the scripts
 in dpkg-dev. They cover a wide range of functionality. Among them
 there are the following public modules:
 .
  - Dpkg: core variables
  - Dpkg::Arch: architecture handling functions
  - Dpkg::BuildFlags: set, modify and query compilation build flags
  - Dpkg::BuildInfo: build information functions
  - Dpkg::BuildOptions: parse and manipulate DEB_BUILD_OPTIONS
  - Dpkg::BuildProfiles: parse and manipulate build profiles
  - Dpkg::Changelog: parse changelogs
  - Dpkg::Changelog::Entry: represents a changelog entry
  - Dpkg::Changelog::Parse: generic changelog parser for dpkg-parsechangelog
  - Dpkg::Checksums: generate and parse checksums
  - Dpkg::Compression: simple database of available compression methods
  - Dpkg::Compression::FileHandle: transparently (de)compress files
  - Dpkg::Compression::Process: wrapper around compression tools
  - Dpkg::Conf: parse dpkg configuration files
  - Dpkg::Control: parse and manipulate Debian control information
    (.dsc, .changes, Packages/Sources entries, etc.)
  - Dpkg::Control::Changelog: represent fields output by dpkg-parsechangelog
  - Dpkg::Control::Fields: manage (list of known) control fields
  - Dpkg::Control::Hash: parse and manipulate a block of RFC822-like fields
  - Dpkg::Control::Info: parse files like debian/control
  - Dpkg::Control::Tests: parse files like debian/tests/control
  - Dpkg::Control::Tests::Entry: represents a debian/tests/control stanza
  - Dpkg::Deps: parse and manipulate dependencies
  - Dpkg::Deps::Simple: represents a single dependency statement
  - Dpkg::Deps::Multiple: base module to represent multiple dependencies
  - Dpkg::Deps::Union: list of unrelated dependencies
  - Dpkg::Deps::AND: list of AND dependencies
  - Dpkg::Deps::OR: list of OR dependencies
  - Dpkg::Deps::KnownFacts: list of installed and virtual packages
  - Dpkg::Exit: push, pop and run exit handlers
  - Dpkg::Gettext: wrapper around Locale::gettext
  - Dpkg::IPC: spawn sub-processes and feed/retrieve data
  - Dpkg::Index: collections of Dpkg::Control (Packages/Sources files for
    example)
  - Dpkg::Interface::Storable: base object serializer
  - Dpkg::Path: common path handling functions
  - Dpkg::Source::Format: manipulate debian/source/format files
  - Dpkg::Source::Package: extract Debian source packages
  - Dpkg::Substvars: substitute variables in strings
  - Dpkg::Vendor: identify current distribution vendor
  - Dpkg::Version: parse and manipulate Debian package versions
 .
 All the packages listed in Suggests or Recommends are used by some of the
 modules.

Package: dselect
Priority: optional
Architecture: any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Suggests:
 libdpkg-perl,
 perl,
Description: Debian package management front-end
 dselect is a high-level interface for managing the installation and
 removal of Debian software packages.
 .
 Many users find dselect intimidating and new users may prefer to use
 apt-based user interfaces.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for the dpkg suite.
# Copyright © 2004 Scott James Remnant <scott@netsplit.com>
# Copyright © 2006-2012 Guillem Jover <guillem@debian.org>

WFLAGS := \
	-Wall -Wextra \
	-Wno-missing-field-initializers \
	-Wno-nonnull-compare \
	-Wno-unused-parameter \
	# EOL

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = $(WFLAGS)
export DEB_CXXFLAGS_MAINT_APPEND = $(WFLAGS)

# Use the in-tree dpkg-buildflags
dpkg_buildflags = \
	DEB_BUILD_MAINT_OPTIONS="$(DEB_BUILD_MAINT_OPTIONS)" \
	DEB_CFLAGS_MAINT_APPEND="$(WFLAGS)" \
	DEB_CXXFLAGS_MAINT_APPEND="$(WFLAGS)" \
	$(CURDIR)/build-aux/run-script scripts/dpkg-buildflags.pl

# Do not enable everything on all platforms.
ifeq ($(DEB_HOST_ARCH_OS),linux)
	confflags += --with-libselinux
endif
ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
	TESTSUITEFLAGS += --verbose
endif

# Enable parallel test suite
NUMJOBS = 1
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  TESTSUITEFLAGS += -j$(NUMJOBS)
endif

testflags = TESTSUITEFLAGS=$(TESTSUITEFLAGS) TEST_PARALLEL=$(NUMJOBS)

D := $(CURDIR)/debian/tmp

%:
	dh $@ --builddirectory=build-tree

override_dh_auto_configure:
	dh_auto_configure -- \
		$(confflags) \
		$(shell $(dpkg_buildflags) --export=configure) \
		--sbindir=/sbin \
		--libexecdir=\$${exec_prefix}/lib \
		--with-devlibdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) \
		--with-libz \
		--with-liblzma \
		--with-libzstd \
		--with-libbz2 \
		# EOL

execute_after_dh_auto_install:
	# Special-case the lintian profile, as dh cannot rename on install.
	mkdir -p $(D)/usr/share/lintian/profiles/dpkg
	cp debian/dpkg.lintian-profile \
	   $(D)/usr/share/lintian/profiles/dpkg/main.profile

override_dh_auto_test:
	dh_auto_test -- $(testflags)

override_dh_installsystemd:
	dh_installsystemd -a --name=dpkg-db-backup \
	  --no-start --no-stop-on-upgrade

execute_after_dh_installlogrotate:
	dh_installlogrotate --name=alternatives

override_dh_installdocs:
	dh_installdocs -Ndpkg-dev
	dh_installdocs -pdpkg-dev --doc-main-package=dpkg

override_dh_installchangelogs:
	dh_installchangelogs --no-trim

override_dh_bugfiles:
	dh_bugfiles -A

override_dh_compress:
	dh_compress -Xspec/

override_dh_builddeb:
	# Make debootstrap life easier on non-Debian based systems by
	# compressing dpkg.deb with xz instead of zstd.
	dh_builddeb -pdpkg -- -Zxz
	dh_builddeb -Ndpkg

## dpkg 1.22.6~bpo12+rpt3

=== debian/changelog ===
dpkg (1.22.6~bpo12+rpt3) bookworm; urgency=medium

  * Since Buster, Debian has been shipping a filesystem layout that is
    unsupported by dpkg.
    - Revert warning in postinst. It links to a page which contains false
      information and may do more harm than good
      Reverts 57e084a52e1ede33b7914c3e0357311ac370a186
  * Do not set -Werror=implicit-function-declaration unconditionally since it
    breaks some builds
    - Reverts 07140b132092e92d8d6b1b6805ff056089951dad

 -- Serge Schneider <serge@raspberrypi.com>  Wed, 12 Jun 2024 09:41:34 +0100

dpkg (1.22.6~bpo12+rpt2) bookworm; urgency=medium

  * Disable time64 feature by default 
    - Reverts 1f0ebe1945724fd57fd3984af0031ce9bf55b524

 -- Serge Schneider <serge@raspberrypi.com>  Wed, 15 May 2024 13:58:44 +0100

dpkg (1.22.6~bpo12+rpt1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Simon Long <simon@raspberrypi.com>  Fri, 10 May 2024 10:54:44 +0100

dpkg (1.22.6) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-deb: Fix up compressor parameters for default legacy format.
  * Perl modules:
    - Dpkg::Vendor::Debian: Make it possible to disable qa=-bug-implicit-func.
      Closes: #1065371
    - Dpkg::Vendor::Debian: Unconditionally set qa bug-implicit-func.
      See #1065371.
  * Documentation:
    - man: Document dpkg versions supporting SOURCE_DATE_EPOCH for various
      tools.
  * Code internals:
    - libdpkg: Use array access instead of pointer arithmetic for meminfo
      parser.
    - libdpkg: Use a macro to define the zstd default compression level.
  * Build system:
    - Test with minimal library dependencies in CI.
    - Add gen-release script.
  * Packaging:
    - Fix typo in man page reference in changelog.
  * Test suite:
    - Refactor OpenPGP backend and commands list.
    - Refactor certfile and keyfile filenames for OpenPGP test.
    - Skip OpenPGP tests if the backend does not have a verify command.
      Closes: #1065648
  * Localization:
    - Fix typos in Swedish man pages translations.
      Thanks to Andreas Rönnquist <gusnan@debian.org>. Closes: #1065672
    - Fix typos in Swedish man pages translations. Closes: #1065575
    - Update Dutch man pages translations.
      Thanks to Frans Spiesschaert <Frans.Spiesschaert@yucom.be>.
      Closes: #1065518
    - Update Portuguese man pages translations.
      Thanks to Américo Monteiro <a_monteiro@gmx.com>. Closes: #1065401

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.

 -- Guillem Jover <guillem@debian.org>  Sun, 10 Mar 2024 20:21:24 +0100

dpkg (1.22.5) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-buildapi: Remove -v alias for --version.
  * dpkg-query: Fix exit codes for --show. Closes: #1064036
  * Perl modules:
    - Dpkg::OpenPGP::Backend::Sequoia: Update to new CLI API changes.
    - Dpkg::OpenPGP::Backend::GnuPG: Add support for Sequoia gpg Chameleon.
    - Dpkg::Vendor::Debian: Only append branch compiler flags if $flag is set.
    - Dpkg::Vendor: Make the add_build_flags() a non-private method.
    - Dpkg::Vendor::Ubuntu: Pass compiler flags to disable features.
      Based on a patch by Matthias Klose <doko@ubuntu.com>.
    - Dpkg::Vendor::Debian: Enable time64 feature by default except on
      <some>-i386. Closes: #1037136
      Based on a patch by Steve Langasek <steve.langasek@ubuntu.com>.
    - Dpkg::Vendor::Debian: Enable qa=+bug-implicit-func for abi=+time64
      feature. Based on a patch by Steve Langasek <steve.langasek@ubuntu.com>.
  * Documentation:
    - man, doc: Fix dpkg-buildapi option and command grouping in descriptions.
    - man: Add spaces around make variable assignments.
    - man: Do not duplicate list of known feature areas in dpkg-buildflags.
    - man: Document known feature areas in DEB_BUILD_OPTIONS for
      dpkg-buildpackage.
    - man: Improve build flags feature specification in environment variables.
      Closes: #1063641
    - man: Use L</> markup for inter link reference.
    - man: Mention Build-Depends-Packages in dpkg-shlibdeps(1).
  * Code internals:
    - libdpkg: Add comment clarifying GNU long name tar format expectations.
    - libdpkg: Use an intermediate mode variable in secure_unlink_statted().
    - dpkg: Rename symlink_len to linksize.
    - dpkg: Rename r variable for readlink() return value to linksize.
    - dpkg: Reduce variable scope in conffderef().
    - libdpkg: Refactor file_readlink() function.
    - libdpkg: Deindent an else clause.
    - lib, src: Fold if with last previous else.
    - perl: Fold if into previous else.
    - dpkg-mergechangelogs: Refactor merge_tail() sub from anonymous sub.
    - dpkg-query: Rename rc variables tracking no matches to misses.
    - dpkg-query: Rename failures variables tracking no matches to misses.
  * Build system:
    - Rename pkexec variables to polkitactions.
    - Move directory definitions to configure.
    - Use PACKAGE_TARNAME for pathname components in directories.
    - Split each automake variable value into its own line.
    - Reorder automake variables.
    - Move update-alternatives rules within automake conditional.
    - Move MD_LIBS from LDFLAGS to LDADD for libdpkg.
    - Fix libdpkg library flags for static and dynamic linking.
    - Add infrastructure for bash-completions.
  * Test suite:
    - Pass -T+1 to xz to workaround spurious warning with xz 5.6.0.
      Closes: #1064856

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.
    - Update German scripts translation.

 -- Guillem Jover <guillem@debian.org>  Tue, 27 Feb 2024 04:28:03 +0100

dpkg (1.22.4) unstable; urgency=medium

  [ Guillem Jover ]
  * Code internals:
    - dpkg: Rename r variable for readlink() return value to symlink_len.
    - dpkg: Rename r variable for fd_read() return value to n.
    - dpkg-deb: Rename r variable for fd_read() return value to nread.
    - dpkg-deb: Rename r variables for fd_read() call chain return value to rc.


=== debian/rules ===
--- 
+++ 
@@ -38,6 +38,11 @@
 
 testflags = TESTSUITEFLAGS=$(TESTSUITEFLAGS) TEST_PARALLEL=$(NUMJOBS)
 
+dpkg_vendor = \
+	$(CURDIR)/build-aux/run-script scripts/dpkg-vendor.pl
+
+DEB_VENDOR = $(shell $(call dpkg_vendor) --query Vendor)
+
 D := $(CURDIR)/debian/tmp
 
 %:
@@ -47,7 +52,6 @@
 	dh_auto_configure -- \
 		$(confflags) \
 		$(shell $(dpkg_buildflags) --export=configure) \
-		--sbindir=/sbin \
 		--libexecdir=\$${exec_prefix}/lib \
 		--with-devlibdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) \
 		--with-libz \
@@ -85,8 +89,22 @@
 override_dh_compress:
 	dh_compress -Xspec/
 
-override_dh_builddeb:
-	# Make debootstrap life easier on non-Debian based systems by
-	# compressing dpkg.deb with xz instead of zstd.
-	dh_builddeb -pdpkg -- -Zxz
-	dh_builddeb -Ndpkg
+ifeq (,$(filter $(DEB_VENDOR),Debian Ubuntu Raspbian))
+execute_after_dh_install:
+	dh_install -pdpkg usr/sbin/dpkg-fsys-usrunmess
+
+# XXX: We cannot use -X, see debhelper #756366.
+execute_after_dh_installman:
+	dh_installman -pdpkg $(wildcard \
+	  $(D)/usr/share/man/*/dpkg-fsys-usrunmess.8  \
+	  $(D)/usr/share/man/*/*/dpkg-fsys-usrunmess.8 \
+	)
+
+# XXX: We cannot pass pathnames to dh_installman w/o $(D), and then dh_missing
+# complains that the pathnames do not match, so ignore them.
+override_dh_missing:
+	dh_missing -Xdpkg-fsys-usrunmess.8
+else
+override_dh_missing:
+	dh_missing -Xdpkg-fsys-usrunmess
+endif

## dpkg 1.22.6deepin3

=== debian/changelog ===
dpkg (1.22.6deepin3) unstable; urgency=medium

  * Enable LSX (128-bit vector extension) optimisation for loong64.

 -- Mingcong Bai <baimingcong@uniontech.com>  Tue, 28 May 2024 10:30:26 +0800

dpkg (1.22.6deepin2) unstable; urgency=medium

  * Revert qa bug-implicit-func changes in 1.22.6.
   * Perl modules:
    - Dpkg::Vendor::Debian: Make it possible to disable qa=-bug-implicit-func.
    - Dpkg::Vendor::Debian: Unconditionally set qa bug-implicit-func.

 -- Tianyu Chen <sweetyfish@deepin.org>  Mon, 27 May 2024 11:28:48 +0800

dpkg (1.22.6deepin1) unstable; urgency=medium

  * Add Dpkg::Vendor::Deepin.

 -- Tianyu Chen <sweetyfish@deepin.org>  Mon, 27 May 2024 11:20:43 +0800

## dpkg 1.22.6deepin4

=== tests/t-file-replaces-disappear/Makefile ===
TESTS_DEB := pkg-file-original pkg-file-takeover

include ../Test.mk

TEST_CASES += test-two-run-ordered
TEST_CASES += test-one-run-ordered
TEST_CASES += test-two-run-reverse
TEST_CASES += test-one-run-reverse

test-case: $(TEST_CASES)

define VERIFY
$(call pkg_is_installed,pkg-file-takeover)
test "`$(DPKG_QUERY) -S /test-file`" = "pkg-file-takeover: /test-file"
test "`$(DPKG_QUERY) -S /test-other`" = "pkg-file-takeover: /test-other"
cmp ref-file "$(DPKG_INSTDIR)/test-file"
cmp ref-file "$(DPKG_INSTDIR)/test-other"
endef

test-two-run-ordered:
	# test-two-run-ordered
	$(DPKG_INSTALL) pkg-file-original.deb
	$(DPKG_INSTALL) pkg-file-takeover.deb
	$(call pkg_is_not_installed,pkg-file-original)
	$(VERIFY)
	$(DPKG_PURGE) pkg-file-original pkg-file-takeover
	test ! -f "$(DPKG_INSTDIR)/test-file"
	test ! -f "$(DPKG_INSTDIR)/test-other"

test-one-run-ordered:
	# test-one-run-ordered
	$(DPKG_INSTALL) pkg-file-original.deb pkg-file-takeover.deb
	$(call pkg_is_not_installed,pkg-file-original)
	$(VERIFY)
	$(DPKG_PURGE) pkg-file-original pkg-file-takeover
	test ! -f "$(DPKG_INSTDIR)/test-file"
	test ! -f "$(DPKG_INSTDIR)/test-other"

test-two-run-reverse:
	# test-two-run-reverse
	$(DPKG_INSTALL) pkg-file-takeover.deb
	$(DPKG_INSTALL) pkg-file-original.deb
	$(call pkg_is_installed,pkg-file-original)
	$(VERIFY)
	$(DPKG_PURGE) pkg-file-original
	test -f "$(DPKG_INSTDIR)/test-file"
	test -f "$(DPKG_INSTDIR)/test-other"
	$(DPKG_PURGE) pkg-file-takeover
	test ! -f "$(DPKG_INSTDIR)/test-file"
	test ! -f "$(DPKG_INSTDIR)/test-other"

test-one-run-reverse:
	# test-one-run-reverse
	$(DPKG_INSTALL) pkg-file-takeover.deb pkg-file-original.deb
	$(call pkg_is_installed,pkg-file-original)
	$(VERIFY)
	$(DPKG_PURGE) pkg-file-original
	test -f "$(DPKG_INSTDIR)/test-file"
	test -f "$(DPKG_INSTDIR)/test-other"
	$(DPKG_PURGE) pkg-file-takeover
	test ! -f "$(DPKG_INSTDIR)/test-file"
	test ! -f "$(DPKG_INSTDIR)/test-other"

test-clean:
	$(DPKG_PURGE) pkg-file-original pkg-file-takeover

=== debian/changelog ===
dpkg (1.22.6deepin4) unstable; urgency=medium

  * fix: add -fPIC cflags.

 -- lichenggang <lichenggang@deepin.org>  Mon, 17 Feb 2025 16:08:36 +0800

=== debian/rules ===
--- 
+++ 
@@ -8,6 +8,7 @@
 	-Wno-missing-field-initializers \
 	-Wno-nonnull-compare \
 	-Wno-unused-parameter \
+	-fPIC \
 	# EOL
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
@@ -89,7 +90,7 @@
 override_dh_compress:
 	dh_compress -Xspec/
 
-ifeq (,$(filter $(DEB_VENDOR),Debian Ubuntu Raspbian))
+ifeq (,$(filter $(DEB_VENDOR),Debian Ubuntu))
 execute_after_dh_install:
 	dh_install -pdpkg usr/sbin/dpkg-fsys-usrunmess

## dpkg 1.22.6deepin7

=== tests/t-triggers-configure/Makefile ===
TESTS_DEB := pkg-activate pkg-interest-0 pkg-interest-1

include ../Test.mk

test-case:
	$(DPKG_INSTALL) pkg-interest-0.deb

	# Activate the trigger, and leave pkg-interest in triggers-pending.
	$(DPKG_INSTALL) --no-triggers pkg-activate.deb
	$(call pkg_status_is,pkg-interest,install ok triggers-pending)

	# Test that an upgrade from triggers-pending passes the previous
	# configured version to "postinst configure".
	$(DPKG_INSTALL) pkg-interest-1.deb

	# Cleanup.
	$(DPKG_PURGE) pkg-interest
	$(DPKG_PURGE) pkg-activate

test-clean:
	-$(DPKG_PURGE) pkg-interest
	-$(DPKG_PURGE) pkg-activate

=== tests/t-unpack-symlink/Makefile ===
TESTS_DEB := pkg-symlink

include ../Test.mk

build-hook:
	ln -fs test-file pkg-symlink/test-symlink

clean-hook:
	$(RM) pkg-symlink/test-symlink

test-case:
	# test unpacking symlinks
	$(DPKG_INSTALL) pkg-symlink.deb
	$(call pkg_is_installed,pkg-symlink)
	test -f "$(DPKG_INSTDIR)/test-file"
	test -L "$(DPKG_INSTDIR)/test-symlink"
	test "`readlink '$(DPKG_INSTDIR)/test-symlink'`" = "test-file"

test-clean:
	$(DPKG_PURGE) pkg-symlink

=== debian/changelog ===
dpkg (1.22.6deepin7) unstable; urgency=medium

  * fix openbuildservice scripts/t/Dpkg_Arch.t test failed.
  * KNOWN_ARCHES_TOTAL 206 > 211.

 -- lichenggang <lichenggang@deepin.org>  Mon, 28 Jul 2025 17:13:53 +0800

dpkg (1.22.6deepin6) unstable; urgency=medium

  * Revert 'fix: add -fPIC cflags.'

 -- Tianyu Chen <sweetyfish@deepin.org>  Mon, 28 Jul 2025 16:48:01 +0800

dpkg (1.22.6deepin5) unstable; urgency=medium

  * feat: add sw64 support.

 -- hudeng <hudeng@deepin.org>  Thu, 29 May 2025 13:48:38 +0800

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: dpkg
 Section: admin
 Priority: required
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
+Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
 Uploaders: Guillem Jover <guillem@debian.org>
 Homepage: https://wiki.debian.org/Teams/Dpkg
 Vcs-Browser: https://git.dpkg.org/cgit/dpkg/dpkg.git
@@ -119,13 +118,12 @@
  patch (>= 2.7),
  make,
  binutils,
- lto-disabled-list,
 Recommends:
  build-essential,
  gcc | c-compiler,
  fakeroot,
- gnupg | sq | sqop | pgpainless-cli,
- gpgv | sq | sqop | pgpainless-cli,
+ gnupg | sq | sqop | pgpainless-cli | sequoia-chameleon-gnupg,
+ gpgv | sq | sqop | pgpainless-cli | sequoia-chameleon-gnupg,
 # Used by dpkg-mergechangelogs.
  libalgorithm-merge-perl,
 Suggests:
@@ -134,7 +132,7 @@
 # Force R³ support, w/o requiring debhelper users to depend on dpkg-dev.
  debhelper (<< 10.10.1~),
 # Uses new sq features, w/o requiring a hard dependency on sq.
- sq (<< 0.28.0~),
+ sq (<< 0.33.0~),
 # Uses required SOP features, w/o requiring a hard dependency on sqop.
  sqop (<< 0.27.2~),
 # Uses required SOP features, w/o requiring a hard dependency on pgpainless.
@@ -170,8 +168,8 @@
  xz-utils (>= 5.4.0),
 Suggests:
  debian-keyring,
- gnupg | sq | sqop | pgpainless-cli,
- gpgv | sq | sqop | pgpainless-cli,
+ gnupg | sq | sqop | pgpainless-cli | sequoia-chameleon-gnupg,
+ gpgv | sq | sqop | pgpainless-cli | sequoia-chameleon-gnupg,
  gcc | c-compiler,
  binutils,
  patch,
@@ -189,7 +187,7 @@
 # versions prior to 1.19.0.
  dgit (<< 3.13~),
 # Uses new sq features, w/o requiring a hard dependency on sq.
- sq (<< 0.28.0~),
+ sq (<< 0.33.0~),
 # Uses required SOP features, w/o requiring a hard dependency on sqop.
  sqop (<< 0.27.2~),
 # Uses required SOP features, w/o requiring a hard dependency on pgpainless.

=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,6 @@
 	-Wno-missing-field-initializers \
 	-Wno-nonnull-compare \
 	-Wno-unused-parameter \
-	-fPIC \
 	# EOL
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all

## dpkg 1.22.6ubuntu6

=== tests/t-conffile-replaces-disappear/Makefile ===
TESTS_DEB := pkg-conff-original pkg-conff-takeover

include ../Test.mk

TEST_CASES += test-two-run-ordered
TEST_CASES += test-one-run-ordered
TEST_CASES += test-two-run-reverse
TEST_CASES += test-one-run-reverse

test-case: $(TEST_CASES)

define VERIFY
$(call pkg_is_installed,pkg-conff-takeover)
test "`$(DPKG_QUERY) -S /test-conffile`" = "pkg-conff-takeover: /test-conffile"
cmp ref-conffile "$(DPKG_INSTDIR)/test-conffile"
endef

test-two-run-ordered:
	# test-two-run-ordered
	$(DPKG_INSTALL) pkg-conff-original.deb
	$(DPKG_INSTALL) pkg-conff-takeover.deb
	$(call pkg_is_not_installed,pkg-conff-original)
	$(VERIFY)
	$(DPKG_PURGE) pkg-conff-original pkg-conff-takeover
	test ! -f "$(DPKG_INSTDIR)/test-conffile"

test-one-run-ordered:
	# test-one-run-ordered
	$(DPKG_INSTALL) pkg-conff-original.deb pkg-conff-takeover.deb
	$(call pkg_is_not_installed,pkg-conff-original)
	$(VERIFY)
	$(DPKG_PURGE) pkg-conff-original pkg-conff-takeover
	test ! -f "$(DPKG_INSTDIR)/test-conffile"

test-two-run-reverse:
	# test-two-run-reverse
	$(DPKG_INSTALL) pkg-conff-takeover.deb
	$(DPKG_INSTALL) pkg-conff-original.deb
	$(call pkg_is_installed,pkg-conff-original)
	$(VERIFY)
	$(DPKG_PURGE) pkg-conff-original pkg-conff-takeover
	test ! -f "$(DPKG_INSTDIR)/test-conffile"

test-one-run-reverse:
	# test-one-run-reverse
	$(DPKG_INSTALL) pkg-conff-takeover.deb pkg-conff-original.deb
	$(call pkg_is_installed,pkg-conff-original)
	$(VERIFY)
	$(DPKG_PURGE) pkg-conff-original pkg-conff-takeover
	test ! -f "$(DPKG_INSTDIR)/test-conffile"

=== debian/changelog ===
dpkg (1.22.6ubuntu6) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 30 Mar 2024 23:51:17 +0000

dpkg (1.22.6ubuntu5) noble; urgency=medium

  * Use -fcf-protection=none instead of -fno-cf-protection.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 26 Mar 2024 17:31:13 +0100

dpkg (1.22.6ubuntu4) noble; urgency=medium

  * Also revert the test case.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 18 Mar 2024 20:18:27 +0000

dpkg (1.22.6ubuntu3) noble; urgency=medium

  * Revert upstream change to enable -Werror=implicit-function-declaration
    by default on all archs: this makes it easier for developers to 
    reproduce build failures on armhf due to time_t, but at the cost of 
    increasing the number of build failures on non-armhf archs and also 
    introducing risk of misbuilds due to failing configure-time checks.  
    Users who need to reproduce armhf build failures can set 
    DEB_BUILD_OPTIONS=qa=+bug-implicit-func, and leaf packages that 
    fail to build only on armhf can be removed from
    the release.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 18 Mar 2024 19:58:54 +0000

dpkg (1.22.6ubuntu2) noble; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Change native source version/format mismatch errors into warnings
      until the dust settles on Debian bug 737634 about override options.
    - Add DPKG_UNTRANSLATED_MESSAGES environment check so that higher-level
      tools can get untranslated dpkg terminal log messages while at the
      same time having translated debconf prompts.
    - Map unqualified package names of multiarch-same packages to the native
      arch instead of throwing an error, so that we don't break on upgrade
      when there are unqualified names stored in the dpkg trigger database.
    - Apply a workaround from mvo to consider ^rc packages as multiarch,
      during the dpkg consistency checks. (see LP: 1015567 and 1057367).
    - dpkg-gencontrol: Fix Package-Type override handling for ddeb support.
    - scripts/Dpkg/Vendor/Ubuntu.pm, scripts/dpkg-buildpackage.pl: set
      'nocheck' in build options by default on Ubuntu/riscv64.  Overridable
      in debian/rules with
      'DEB_BUILD_OPTIONS := $(filter-out nocheck,$(DEB_BUILD_OPTIONS))'.
    - dpkg-dev: Depend on lto-disabled-list.
    - dpkg-buildflags: Read package source names from lto-disabled-list,
      to build without lto optimizations. When adding a source package to the
      list, please also file a launchpad issue and tag it with 'lto'.
    - scripts/Dpkg/Vendor/Ubuntu.pm: set 'noudeb' build profile by
      default. Override this by exporting DEB_BUILD_PROFILE='!noudeb' which
      will be stripped, and thus building with udebs.
    - build: Switch default dpkg-deb compression from xz to zstd.
      Keep compressing dpkg.deb with xz to help bootstrapping on non-Ubuntu
      systems.
    - set default zstd compression level to 19
    - scripts/Dpkg/Vendor/Debian.pm: Always include "-fdebug-prefix-map"
      to build flags.  Map path to "/usr/src/PKGNAME-PKGVER" instead of
      ".", honouring the DWARF standard which prohibits relative paths
      in DW_AT_comp_dir.
    - scripts/{mk/buildflags.mk,t.mk}: Add support for DEB_BUILD_DEBUGPATH.
    - man/dpkg-buildflags.pod: Document new behaviour of "fdebugmap" and
      new DEB_BUILD_DEBUGPATH variable.
    - Disable -fstack-clash-protection on armhf since it causes crashes
    - dpkg-buildflags: Add a new feature "framepointer" in the "qa" area.
    - Turn on the use of frame pointers by default on 64bit architectures.
    - Update _FORTIFY_SOURCE documentation.
    - Update Dpkg_BuildFlags test case.
    - Fix debian/rules duplicate invocations of dh_builddeb
    - lib/dpkg/compress.c: clean up override of the default zstd compression
      level
    - dpkg-buildflags: Explicitly turn off hardening flags when requested.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 16 Mar 2024 07:45:39 +0100

dpkg (1.22.5ubuntu4) noble; urgency=medium

  * dpkg-buildflags: Don't enable qa=bug-implicit-func by default for time64.
    -Werror=implicit-function-declaration causes unrelated ftbfs.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 03 Mar 2024 16:18:36 +0100

dpkg (1.22.5ubuntu2) noble; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Change native source version/format mismatch errors into warnings
      until the dust settles on Debian bug 737634 about override options.
    - Add DPKG_UNTRANSLATED_MESSAGES environment check so that higher-level
      tools can get untranslated dpkg terminal log messages while at the
      same time having translated debconf prompts.
    - Map unqualified package names of multiarch-same packages to the native
      arch instead of throwing an error, so that we don't break on upgrade
      when there are unqualified names stored in the dpkg trigger database.
    - Apply a workaround from mvo to consider ^rc packages as multiarch,
      during the dpkg consistency checks. (see LP: 1015567 and 1057367).
    - dpkg-gencontrol: Fix Package-Type override handling for ddeb support.
    - scripts/Dpkg/Vendor/Ubuntu.pm, scripts/dpkg-buildpackage.pl: set
      'nocheck' in build options by default on Ubuntu/riscv64.  Overridable
      in debian/rules with
      'DEB_BUILD_OPTIONS := $(filter-out nocheck,$(DEB_BUILD_OPTIONS))'.
    - dpkg-dev: Depend on lto-disabled-list.
    - dpkg-buildflags: Read package source names from lto-disabled-list,
      to build without lto optimizations. When adding a source package to the
      list, please also file a launchpad issue and tag it with 'lto'.
    - scripts/Dpkg/Vendor/Ubuntu.pm: set 'noudeb' build profile by
      default. Override this by exporting DEB_BUILD_PROFILE='!noudeb' which
      will be stripped, and thus building with udebs.
    - build: Switch default dpkg-deb compression from xz to zstd.


## dpkg 1.22.6ubuntu6.1

=== debian/changelog ===
dpkg (1.22.6ubuntu6.1) noble-security; urgency=medium

  * SRU:
    - Disable framepointer on ppc64el. LP: #2064539.
    - Disable framepointer on s390x, leaving only -mbackchain. LP: #2064538.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 17 Jul 2024 11:09:50 +0200

## dpkg 1.22.6ubuntu6.1trisquel5

=== debian/changelog ===
dpkg (1.22.6ubuntu6.1trisquel5) ecne-security; urgency=medium

  * Compiled for Trisquel

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Tue, 10 Sep 2024 18:34:38 +0000

## dpkg 1.22.6ubuntu6.2

=== debian/changelog ===
dpkg (1.22.6ubuntu6.2) noble; urgency=medium

  [ Zixing Liu ]
  * Add RUSTFLAGS to define frame pointers for Rust toolchain (LP: #2082636).
  * Replaces mainline version number 1.22.6ubuntu12 with 1.22.6ubuntu6.2 in
    the documentation to avoid confusion with backported version.

  [ Benjamin Drung ]
  * buildflags: document RUSTFLAGS
  * buildflags: Always set RUSTFLAGS

 -- Zixing Liu <zixing.liu@canonical.com>  Thu, 26 Sep 2024 13:14:01 -0600

## dpkg 1.22.6ubuntu6.2trisquel5

=== debian/changelog ===
dpkg (1.22.6ubuntu6.2trisquel5) ecne; urgency=medium

  * Compiled for Trisquel

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Thu, 18 Sep 2025 06:47:53 +0000

## dpkg 1.22.6ubuntu6.3

=== tests/t-conflict-provide-replace-real/Makefile ===
TESTS_DEB := pkg-a pkg-b

include ../Test.mk

test-case:
	$(DPKG_INSTALL) pkg-a.deb
	# test if the replacing package takes over on install
	$(DPKG_INSTALL) pkg-b.deb

test-clean:
	$(DPKG_PURGE) pkg-b
	-$(DPKG_PURGE) pkg-a

=== debian/changelog ===
dpkg (1.22.6ubuntu6.3) noble; urgency=medium

  [ Joy Latten ]
  * SRU:
  - Fix cleanup for control member with restricted directories. LP: #2122053
  - Fixes CVE-2025-6297

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Thu, 18 Sep 2025 12:43:59 -0500
